﻿using Buddy.Coroutines;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = _CoRo___Frost_.Core.Utilities.Log;
using SB = _CoRo___Frost_.Core.Helpers.Spell_Book;
using U = _CoRo___Frost_.Core.Unit;
#endregion

namespace _CoRo___Frost_.Core
{
    class Spell
    {
        public static int lastSpellCast;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Cooldown Detection
        public static double cooldownTimeLeft(int Spell)
        {
            try
            {
                SpellFindResults Results;
                return SpellManager.FindSpell(Spell, out Results) ? (Results.Override != null ? Results.Override.CooldownTimeLeft.TotalMilliseconds : Results.Original.CooldownTimeLeft.TotalMilliseconds) : 9999;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in cooldownTimeLeft(): ", xException);
                return 9999;
            }
        }
        public static bool onCooldown(int Spell)
        {
            try
            {
                SpellFindResults Results;
                if (SpellManager.FindSpell(Spell, out Results)) { return Results.Override != null ? Results.Override.Cooldown : Results.Original.Cooldown; }
                return false;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in onCooldown(): ", xException);
                return false;
            }
        }
        #endregion

        #region [Method] - Spell Casting
        public static async Task<bool> Buff(int Spell, bool reqs)
        {
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), Me, false, false, false))
                return false;
            if (!SpellManager.Cast(Spell, Me))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            L.combatLog("D:{0} F:{1} U:{2} RP:{3}", Me.DeathRuneCount.ToString(), Me.FrostRuneCount.ToString(), Me.UnholyRuneCount.ToString(), U.luaGetPower().ToString());
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> Cast(int Spell, bool reqs)
        {
            if (!U.isUnitValid(currentTarget))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), currentTarget, false, false, false))
                return false;
            if (!SpellManager.Cast(Spell, currentTarget))
                return false;
            if (Spell == SB.spellPestilence) { spellTimer.Reset(); }
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            L.combatLog("D:{0} F:{1} U:{2} RP:{3}", Me.DeathRuneCount.ToString(), Me.FrostRuneCount.ToString(), Me.UnholyRuneCount.ToString(), U.luaGetPower().ToString());
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> Drop(int Spell, bool reqs)
        {
            if (!U.isUnitValid(currentTarget))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), currentTarget, false, false, false))
                return false;
            if (!SpellManager.Cast(Spell, currentTarget))
                return false;
            if (!await Coroutine.Wait(10, () => Me.CurrentPendingCursorSpell != null))
            {
                L.diagnosticLog("Exception in Cast(): Death and Decay failed to cast");
                return false;
            }
            SpellManager.ClickRemoteLocation(currentTarget.Location);
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            L.combatLog("D:{0} F:{1} U:{2} RP:{3}", Me.DeathRuneCount.ToString(), Me.FrostRuneCount.ToString(), Me.UnholyRuneCount.ToString(), U.luaGetPower().ToString());
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> GCD(int Spell, bool reqs)
        {
            if (!reqs)
                return false;
            if (!SpellManager.Cast(Spell, Me))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            L.combatLog("D:{0} F:{1} U:{2} RP:{3}", Me.DeathRuneCount.ToString(), Me.FrostRuneCount.ToString(), Me.UnholyRuneCount.ToString(), U.luaGetPower().ToString());
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        #endregion

        #region [Method] - Usage Timer
        public static WaitTimer spellTimer = new WaitTimer(TimeSpan.FromMilliseconds(28000));
        #endregion
    }
}
