﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = _CoRo___Frost_.Core.Utilities.Log;
using SB = _CoRo___Frost_.Core.Helpers.Spell_Book;
#endregion

namespace _CoRo___Frost_.Core
{
    class Unit
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Active Enemies
        public static IEnumerable<WoWUnit> activeEnemies(WoWPoint fromLocation, double Range)
        {
            var Hostile = enemyCount;
            return Hostile != null ? Hostile.Where(x => x.Location.DistanceSqr(fromLocation) <= Range * Range) : null;
        }
        private static List<WoWUnit> enemyCount { get; set; }
        public static void enemyAnnex(double Range)
        {
            enemyCount.Clear();
            foreach (var u in surroundingEnemies())
            {
                if (u == null || !u.IsValid)//<~ Use isUnitValid(u, Range) instead of the frist five of these first calls?
                    continue;
                if (!u.IsAlive || u.DistanceSqr > Range * Range)
                    continue;
                if (!u.Attackable || !u.CanSelect)
                    continue;
                if (u.IsFriendly)
                    continue;
                if (u.IsNonCombatPet && u.IsCritter)
                    continue;
                enemyCount.Add(u);
            }
        }
        private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }
        static Unit() { enemyCount = new List<WoWUnit>(); }
        #endregion

        #region [Method] - Aura Detection
        public static bool auraExists(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraExists(): ", xException);
                return false;
            }
        }
        public static uint auraStacks(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.StackCount : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraStacks(): ", xException);
                return 0;
            }
        }
        public static double auraTimeLeft(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraTimeLeft(): ", xException);
                return 9999;
            }
        }
        #endregion

        #region [Method] - Cache
        public static uint bloodCharge;
        public static bool bloodPlague;
        public static int deathRunes;
        public static bool frostFever;
        public static int frostRunes;
        public static bool killingMachine;
        public static double Mastery;
        public static bool pillarofFrost;
        public static bool Rime;
       // public static bool Bos;
        public static double runicPower;
        public static int unholyRunes;

        public static void Cache()
        {
            bloodCharge = auraStacks(Me, SB.auraBloodCharge);
            bloodPlague = auraExists(currentTarget, SB.auraBloodPlague, true);
            deathRunes = Me.DeathRuneCount;
            frostFever = auraExists(currentTarget, SB.auraFrostFever, true);
            frostRunes = Me.FrostRuneCount;
            killingMachine = auraExists(Me, SB.auraKillingMachine);
            Mastery = getMastery();
            pillarofFrost = auraExists(Me, SB.auraPillarofFrost);
            Rime = auraExists(Me, SB.auraFreezingFog);
            //Bos = auraExists(Me, SB.auraBos, true);
            runicPower = luaGetPower();
            unholyRunes = Me.UnholyRuneCount;
        }
        #endregion

        #region [Method] - Unit Evaluation
        private static float calculateMeleeRange(WoWUnit Unit) { return !Me.GotTarget ? 0f : Math.Max(5f, Me.CombatReach + 1.3333334f + Unit.CombatReach); }
        public static bool isInMeleeRange(WoWUnit Unit) { return Unit.Distance < calculateMeleeRange(Unit); }
        public static bool isUnitValid(WoWUnit Unit) { return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && isInMeleeRange(Unit); }
        public static double luaGetPower()
        {
            try
            {
                using (StyxWoW.Memory.AcquireFrame()) { return Lua.GetReturnVal<int>("return UnitPower(\"player\");", 0); }
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in playerPower(): ", xException);
                return Me.CurrentPower;
            }
        }
        public static double getMastery()
        {
            return Me.GetCombatRating(WoWPlayerCombatRating.Mastery);
        }
        #endregion
    }
}
