﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using HKM = _CoRo___Frost_.Core.Managers.Hotkey_Manager;
using S = _CoRo___Frost_.Core.Spell;
using SB = _CoRo___Frost_.Core.Helpers.Spell_Book;
using TM = _CoRo___Frost_.Core.Managers.Talent_Manager;
using U = _CoRo___Frost_.Core.Unit;
#endregion

namespace _CoRo___Frost_.Rotation
{
    class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Precombat Buffing
        public static async Task<bool> preCombatBuffing()
        {
            if (HKM.manualOn || Me.Combat || !Me.IsAlive || (Me.Mounted || Me.OnTaxi))
                return true;
            //actions.precombat=flask,type=winters_bite
            //actions.precombat+=/food,type=black_pepper_ribs_and_shrimp
            return await S.Buff(SB.spellFrostPresence,  !U.auraExists(Me, SB.auraFrostPresence));
            //actions.precombat+=/army_of_the_dead
            //actions.precombat+=/mogu_power_potion
            //actions.precombat+=/pillar_of_frost
        }
        #endregion

        #region [Method] - Combat Buffing
        public static async Task<bool> combatBuffing()
        {
            if (HKM.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            if (!Me.IsAutoAttacking) { Lua.DoString("StartAttack()"); return true; }
            //actions+=/antimagic_shell,damage=100000
            await S.GCD(SB.spellPillarofFrost,      HKM.cooldownsOn && !S.onCooldown(SB.spellPillarofFrost) && U.isInMeleeRange(currentTarget));
            //actions+=/mogu_power_potion,if=target.time_to_die<=30|(target.time_to_die<=60&buff.pillar_of_frost.up)
            //actions+=/empower_rune_weapon,if=target.time_to_die<=60&(buff.mogu_power_potion.up|buff.golemblood_potion.up)
            await S.GCD(SB.spellBloodFury,          HKM.cooldownsOn && Me.Race == WoWRace.Orc && !S.onCooldown(SB.spellBloodFury) && U.isInMeleeRange(currentTarget));
            await S.GCD(SB.spellBerserking,         HKM.cooldownsOn && Me.Race == WoWRace.Troll && !S.onCooldown(SB.spellBerserking) && U.isInMeleeRange(currentTarget));
            await S.GCD(SB.spellArcaneTorrent,      HKM.cooldownsOn && Me.Race == WoWRace.BloodElf && !S.onCooldown(SB.spellArcaneTorrent) && U.isInMeleeRange(currentTarget));
            //if (HKM.cooldownsOn && Me.Inventory.Equipped.Hands.Cooldown == 0 && U.isInMeleeRange(currentTarget)) { Lua.DoString("RunMacroText('/use 10');"); return false; }
            return await S.Buff(SB.spellRaiseDead,  HKM.cooldownsOn && U.pillarofFrost);
        }
        #endregion

        #region [Method] - Combat Rotation
    // MAIN AOE ROTATION
    // !SB.BoS - breath of sindragosa not active
        #region [Method] - Area of Effect
        public static async Task<bool> AoE()
        {
            if (await S.Cast(SB.spellOutbreak,              (!U.bloodPlague && U.runicPower > 30 && !S.onCooldown(SB.spellOutbreak)))) return true;
            if (await S.Cast(SB.spellBloodBoil,            U.bloodPlague && U.deathRunes == 1)) return true;
            if (await S.Drop(SB.spellDeathandDecay,         U.unholyRunes > 0)) return true;
            if (await S.Cast(SB.spellHowlingBlast,          true)) return true;
            await S.GCD(SB.spellBloodTap,                   TM.canBloodTap(10));
            if (await S.Cast(SB.spellFrostStrike,           U.runicPower > 76 && !U.auraExists(Me, 152279, true))) return true;
           
          
            await S.GCD(SB.spellBloodTap,                   TM.canBloodTap(5));
            if (await S.Cast(SB.spellPlagueLeech,           TM.canPlagueLeech() && !U.auraExists(Me, 152279, true))) return true;
            if (await S.Cast(SB.spellFrostStrike,           !U.auraExists(Me, 152279, true))) return true;


            return await S.GCD(SB.spellEmpowerRuneWeapon,   SB.canEmpowerRuneWeapon());
        }
        #endregion

    // MAIN SINGLE TARGET ROTATION
        #region [Method] - Master Complex
        public static async Task<bool> masterComplex()
        {
            await S.GCD(SB.spellBloodTap,                   TM.canBloodTap(5) && currentTarget.HealthPercent < 35 && !S.onCooldown(SB.spellSoulReaper));
            if (await S.Cast(SB.spellSoulReaper,            currentTarget.HealthPercent < 35)) return true;
            if (await S.Cast(SB.spellOutbreak,              (!U.bloodPlague && U.runicPower > 30 && !S.onCooldown(SB.spellOutbreak)))) return true;           
            if (await S.Cast(SB.spellFrostStrike,           !U.killingMachine && U.runicPower > 90 && !U.auraExists(Me, 152279, true))) return true;            
              if (await S.Cast(SB.spellObliterate,            U.killingMachine && (U.unholyRunes > 0 && U.deathRunes > 0) || (U.deathRunes > 1) || (U.frostRunes > 0 && U.deathRunes > 0) || (U.unholyRunes > 0 && U.frostRunes > 0))) return true;
            if (await S.Cast(SB.spellHowlingBlast,          U.Rime)) return true;
            await S.GCD(SB.spellBloodTap,                   TM.canBloodTap(10));
            if (await S.Cast(SB.spellFrostStrike,           !U.killingMachine && U.runicPower > 75 && !U.auraExists(Me, 152279, true))) return true;           
        
            if (await S.Cast(SB.spellObliterate,            U.unholyRunes > 0 && U.deathRunes > 0) || (U.frostRunes > 0 && U.deathRunes > 0) || (U.deathRunes > 1) || (U.unholyRunes > 0 && U.frostRunes > 0)) return true;
            if (await S.Cast(SB.spellPlagueLeech,           TM.canPlagueLeech() && !U.auraExists(Me, 152279, true))) return true;  
            await S.GCD(SB.spellBloodTap,                   (TM.canBloodTap(5) && U.killingMachine));
            if (await S.Cast(SB.spellFrostStrike,           !U.killingMachine && U.runicPower > 25 && !U.auraExists(Me, 152279, true))) return true;
               // if (await S.Cast(SB.spellHowlingBlast,      !U.frostFever)) return true;
            await S.GCD(SB.spellBloodTap,                   TM.canBloodTap(5));
             if (await S.Cast(SB.spellFrostStrike,           U.killingMachine && U.runicPower > 85 && !U.auraExists(Me, 152279, true))) return true;              
            return await S.GCD(SB.spellEmpowerRuneWeapon,   SB.canEmpowerRuneWeapon());
        }
        #endregion
    // not used
        #region [Method] - Master Simple
        public static async Task<bool> masterSimple()
        {
            await S.GCD(SB.spellBloodTap,               TM.canBloodTap(10) && (U.runicPower > 76 || (U.runicPower > 19 && U.killingMachine)));
            if (await S.Cast(SB.spellSoulReaper,            currentTarget.HealthPercent < 35)) return true;
            if (await S.Cast(SB.spellFrostStrike,       U.killingMachine || U.runicPower > 88)) return true;
            if (await S.Cast(SB.spellHowlingBlast,      U.deathRunes > 1 || U.frostRunes > 1)) return true;
            if (await S.Cast(SB.spellPlagueStrike,      (!U.bloodPlague || U.auraTimeLeft(currentTarget, SB.auraBloodPlague, true) < 3000) && U.unholyRunes > 0)) return true;
            if (await S.Cast(SB.spellFrostStrike,       U.runicPower > 76)) return true;
            if (await S.Cast(SB.spellHowlingBlast,      true)) return true;
            await S.GCD(SB.spellBloodTap,               (TM.canBloodTap(4) && currentTarget.HealthPercent > 35) || TM.canBloodTap(7));
            if (await S.Cast(SB.spellFrostStrike,       U.runicPower > 39)) return true;
            await S.GCD(SB.spellBloodTap,               TM.canBloodTap(4));
            if (await S.Cast(SB.spellPlagueLeech,       /*U.auraTimeLeft(currentTarget, SB.auraBloodPlague, true) < 3000 &&*/ TM.canPlagueLeech())) return true;
            await S.GCD(SB.spellEmpowerRuneWeapon,      SB.canEmpowerRuneWeapon());
            if (await S.Drop(SB.spellDeathandDecay,     U.unholyRunes > 0 && !U.pillarofFrost)) return true;
            return await S.Cast(SB.spellPlagueStrike,   S.onCooldown(SB.spellDeathandDecay) && U.unholyRunes > 0);
        }
        #endregion
     // not used end
        #region [Method] - Rotation Selector
        public static async Task<bool> rotationSelector()
        {
            if (HKM.manualOn || !Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            /*Add Global Calls Here*/
            //await S.GCD(SB.spellBloodTap, TM.canBT(4));
            if ((HKM.aoeOn || U.activeEnemies(Me.Location, 10f).Count() > 3/*Change to GUI setting*/) && await AoE()) return true;
            else return await masterComplex();
        }
        #endregion

        #endregion
    }
}
